var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { Node, Extension, getExtensionField, InputRule, wrappingInputRule, mergeAttributes, isNodeActive, markInputRule, markPasteRule, Editor } from "@tiptap/core";
import { PluginKey, Plugin, TextSelection } from "prosemirror-state";
import Suggestion from "@tiptap/suggestion";
import { DecorationSet, Decoration } from "prosemirror-view";
import { Step } from "prosemirror-transform";
import { sendableSteps, getVersion, receiveTransaction, collab } from "prosemirror-collab";
import "prosemirror-markdown";
import CodeBlockLowlight from "@tiptap/extension-code-block-lowlight";
import Text from "@tiptap/extension-text";
import TiptapImage from "@tiptap/extension-image";
import { generateRemoteUrl, generateUrl } from "@nextcloud/router";
import { getCurrentUser } from "@nextcloud/auth";
import { NodeViewWrapper, VueNodeViewRenderer, EditorContent } from "@tiptap/vue-2";
import ClickOutside from "vue-click-outside";
import Vue from "vue";
import Vuex, { Store } from "vuex";
import { getBuilder } from "@nextcloud/browser-storage";
import TiptapBulletList from "@tiptap/extension-bullet-list";
import TipTapTaskItem from "@tiptap/extension-task-item";
import { findParentNodeClosestToPos } from "prosemirror-utils";
import TiptapTaskList from "@tiptap/extension-task-list";
import TipTapHeading from "@tiptap/extension-heading";
import container from "markdown-it-container";
import Document from "@tiptap/extension-document";
import Paragraph from "@tiptap/extension-paragraph";
import Blockquote from "@tiptap/extension-blockquote";
import OrderedList from "@tiptap/extension-ordered-list";
import ListItem from "@tiptap/extension-list-item";
import CodeBlock from "@tiptap/extension-code-block";
import HorizontalRule from "@tiptap/extension-horizontal-rule";
import Dropcursor from "@tiptap/extension-dropcursor";
import { Table as Table$1 } from "@tiptap/extension-table";
import { TableCell as TableCell$1 } from "@tiptap/extension-table-cell";
import { TableHeader as TableHeader$1 } from "@tiptap/extension-table-header";
import { TableRow as TableRow$1 } from "@tiptap/extension-table-row";
import { isInTable, selectionCell, moveCellForward } from "prosemirror-tables";
import TipTapItalic from "@tiptap/extension-italic";
import TipTapLink from "@tiptap/extension-link";
import MarkdownIt from "markdown-it";
import taskLists from "markdown-it-task-lists";
import TipTapStrike from "@tiptap/extension-strike";
import { Bold, starInputRegex, starPasteRegex, underscoreInputRegex, underscorePasteRegex } from "@tiptap/extension-bold";
import TipTapUnderline from "@tiptap/extension-underline";
/*
 * @copyright Copyright (c) 2021 Jonas <jonas@freesources.org>
 *
 * @author Jonas <jonas@freesources.org>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const EmojiPluginKey = new PluginKey("emoji");
Node.create({
  name: "emoji",
  addOptions() {
    return {
      HTMLAttributes: {},
      suggestion: {
        char: ":",
        pluginKey: EmojiPluginKey,
        command: ({ editor, range, props }) => {
          editor.chain().focus().insertContentAt(range, props.native + " ").run();
        }
      }
    };
  },
  content: "text*",
  addCommands() {
    return {
      emoji: (emojiObject) => ({ commands }) => {
        return commands.insertContent(emojiObject.native + " ");
      }
    };
  },
  addProseMirrorPlugins() {
    return [
      Suggestion(__spreadValues({
        editor: this.editor
      }, this.options.suggestion))
    ];
  }
});
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
Extension.create({
  name: "customkeymap",
  addKeyboardShortcuts() {
    return this.options;
  },
  addProseMirrorPlugins() {
    return [
      new Plugin({
        props: {
          handleKeyDown(view, event) {
            const key = event.key || event.keyCode;
            if ((event.ctrlKey || event.metaKey) && !event.shiftKey && (key === "f" || key === 70)) {
              event.stopPropagation();
              window.dispatchEvent(event);
              return true;
            }
          }
        }
      })
    ];
  }
});
/*
 * @copyright Copyright (c) 2020 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
class Span {
  constructor(from, to, author) {
    this.from = from;
    this.to = to;
    this.author = author;
  }
}
/*
 * @copyright Copyright (c) 2021 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
function updateBlameMap(map, transform, clientIDs) {
  const result = [];
  const mapping = transform.mapping;
  for (let i = 0; i < map.length; i++) {
    const span = map[i];
    const from = mapping.map(span.from, 1);
    const to = mapping.map(span.to, -1);
    if (from < to)
      result.push(new Span(from, to, span.author));
  }
  for (let i = 0; i < mapping.maps.length; i++) {
    const map2 = mapping.maps[i];
    const after = mapping.slice(i + 1);
    map2.forEach((_s, _e, start, end) => {
      insertIntoBlameMap(result, after.map(start, 1), after.map(end, -1), clientIDs[i]);
    });
  }
  return result;
}
function insertIntoBlameMap(map, from, to, author) {
  if (from >= to) {
    return;
  }
  let pos = 0;
  let next;
  for (; pos < map.length; pos++) {
    next = map[pos];
    if (next.author === author) {
      if (next.to >= from)
        break;
    } else if (next.to > from) {
      if (next.from < from) {
        const left = new Span(next.from, from, next.author);
        if (next.to > to)
          map.splice(pos++, 0, left);
        else
          map[pos++] = left;
      }
      break;
    }
  }
  while (next = map[pos]) {
    if (next.author === author) {
      if (next.from > to)
        break;
      from = Math.min(from, next.from);
      to = Math.max(to, next.to);
      map.splice(pos, 1);
    } else {
      if (next.from >= to)
        break;
      if (next.to > to) {
        map[pos] = new Span(to, next.to, next.author);
        break;
      } else {
        map.splice(pos, 1);
      }
    }
  }
  map.splice(pos, 0, new Span(from, to, author));
}
class TrackState {
  constructor(blameMap) {
    this.blameMap = blameMap;
  }
  applyTransform(transform) {
    var _a;
    const clientID = (_a = transform.getMeta("clientID")) != null ? _a : transform.steps.map((item) => "self");
    const newBlame = updateBlameMap(this.blameMap, transform, clientID);
    return new TrackState(newBlame);
  }
}
/*
 * @copyright Copyright (c) 2020 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
Extension.create({
  name: "users",
  addOptions() {
    return {
      clientID: 0,
      color: (clientID) => {
        return "#" + Math.floor(Math.abs(Math.sin(clientID) * 16777215) % 16777215).toString(16) + "aa";
      },
      name: (clientID) => {
        return "Unknown user " + clientID;
      }
    };
  },
  addProseMirrorPlugins() {
    return [
      new Plugin({
        clientID: this.options.clientID,
        color: this.options.color,
        name: this.options.name,
        state: {
          init(_, instance) {
            return {
              tracked: new TrackState([new Span(0, instance.doc.content.size, null)], [], [], []),
              deco: DecorationSet.empty
            };
          },
          apply(tr, instance, oldState, state) {
            let { tracked, decos } = instance;
            let tState = this.getState(oldState).tracked;
            if (tr.docChanged) {
              if (!tr.getMeta("clientID")) {
                tr.setMeta("clientID", tr.steps.map((i) => this.spec.clientID));
              }
              tracked = tracked.applyTransform(tr);
              tState = tracked;
            }
            decos = tState.blameMap.map((span) => {
              const clientID = span.author;
              return Decoration.inline(span.from, span.to, {
                class: "author-annotation",
                style: "background-color: " + this.spec.color(clientID) + "66;",
                title: this.spec.name(clientID)
              });
            }).filter((dec) => dec !== null);
            return { tracked, deco: DecorationSet.create(state.doc, decos) };
          }
        },
        props: {
          decorations(state) {
            return this.getState(state).deco;
          }
        }
      })
    ];
  }
});
let timeout;
const debounce = (fn, delay) => (...args) => {
  if (timeout) {
    clearTimeout(timeout);
  }
  timeout = setTimeout(() => {
    fn(...args);
    timeout = null;
  }, delay);
};
Extension.create({
  name: "collaboration",
  onCreate() {
    this.getSendableSteps = debounce((state) => {
      const sendable = sendableSteps(state);
      if (sendable && this.editor.options.editable) {
        this.options.onSendable({
          editor: this.editor,
          sendable: {
            version: sendable.version,
            steps: sendable.steps.map((step) => step.toJSON()),
            clientID: sendable.clientID
          }
        });
      }
    }, this.options.debounce);
    this.editor.on("transaction", ({ editor }) => {
      this.getSendableSteps(editor.state);
    });
  },
  addOptions() {
    return {
      version: 0,
      clientID: Math.floor(Math.random() * 4294967295),
      debounce: 250,
      onSendable: () => {
      },
      update: ({ steps, version }) => {
        const { state, view, schema } = this.editor;
        if (getVersion(state) > version) {
          return;
        }
        view.dispatch(receiveTransaction(state, steps.map((item) => Step.fromJSON(schema, item.step)), steps.map((item) => item.clientID)));
      }
    };
  },
  addProseMirrorPlugins() {
    return [
      collab({
        version: this.options.version,
        clientID: this.options.clientID
      })
    ];
  }
});
/*
 * @copyright Copyright (c) 2022 Max <max@nextcloud.com>
 *
 * @author Max <max@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
Extension.create({
  name: "markdown",
  extendMarkSchema(extension) {
    const context = {
      name: extension.name,
      options: extension.options,
      storage: extension.storage
    };
    return {
      toMarkdown: getExtensionField(extension, "toMarkdown", context)
    };
  },
  extendNodeSchema(extension) {
    const context = {
      name: extension.name,
      options: extension.options,
      storage: extension.storage
    };
    return {
      toMarkdown: getExtensionField(extension, "toMarkdown", context)
    };
  }
});
var path = {};
var render$2 = function __render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("span", _vm._b({
    staticClass: "material-design-icon trash-can-icon",
    attrs: {
      "aria-hidden": !_vm.title,
      "aria-label": _vm.title,
      "role": "img"
    },
    on: {
      "click": function click($event) {
        return _vm.$emit("click", $event);
      }
    }
  }, "span", _vm.$attrs, false), [_c("svg", {
    staticClass: "material-design-icon__svg",
    attrs: {
      "fill": _vm.fillColor,
      "width": _vm.size,
      "height": _vm.size,
      "viewBox": "0 0 24 24"
    }
  }, [_c("path", {
    attrs: {
      "d": "M9,3V4H4V6H5V19A2,2 0 0,0 7,21H17A2,2 0 0,0 19,19V6H20V4H15V3H9M9,8H11V17H9V8M13,8H15V17H13V8Z"
    }
  }, [_vm.title ? _c("title", [_vm._v(_vm._s(_vm.title))]) : _vm._e()])])]);
};
var staticRenderFns$2 = [];
function normalizeComponent(scriptExports, render2, staticRenderFns2, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render2) {
    options.render = render2;
    options.staticRenderFns = staticRenderFns2;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function(context) {
      context = context || this.$vnode && this.$vnode.ssrContext || this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}
const __vue2_script$2 = {
  name: "TrashCanIcon",
  props: {
    title: {
      type: String
    },
    fillColor: {
      type: String,
      default: "currentColor"
    },
    size: {
      type: Number,
      default: 24
    }
  }
};
const __cssModules$2 = {};
var __component__$2 = /* @__PURE__ */ normalizeComponent(__vue2_script$2, render$2, staticRenderFns$2, false, __vue2_injectStyles$2, null, null, null);
function __vue2_injectStyles$2(context) {
  for (let o in __cssModules$2) {
    this[o] = __cssModules$2[o];
  }
}
var TrashCanIcon = /* @__PURE__ */ function() {
  return __component__$2.exports;
}();
/*
 * @copyright Copyright (c) 2020 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const persistentStorage = getBuilder("text").persist().build();
Vue.use(Vuex);
const store$1 = new Store({
  state: {
    showAuthorAnnotations: persistentStorage.getItem("showAuthorAnnotations") === "true",
    currentSession: persistentStorage.getItem("currentSession")
  },
  mutations: {
    SET_SHOW_AUTHOR_ANNOTATIONS(state, value) {
      state.showAuthorAnnotations = value;
      persistentStorage.setItem("showAuthorAnnotations", "" + value);
    },
    SET_CURRENT_SESSION(state, value) {
      state.currentSession = value;
      persistentStorage.setItem("currentSession", value);
    }
  },
  actions: {
    setShowAuthorAnnotations({ commit }, value) {
      store$1.commit("SET_SHOW_AUTHOR_ANNOTATIONS", value);
    },
    setCurrentSession({ commit }, value) {
      store$1.commit("SET_CURRENT_SESSION", value);
    }
  }
});
/*
 * @copyright Copyright (c) 2021 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
var store = {
  data() {
    return {
      $store: store$1
    };
  },
  beforeMount() {
    if (typeof this.$store === "undefined") {
      this.$store = store$1;
    }
  }
};
var render$1 = function __render__2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("NodeViewWrapper", [_c("div", {
    staticClass: "image",
    class: {
      "icon-loading": !_vm.loaded
    },
    attrs: {
      "data-component": "image-view",
      "data-src": _vm.src
    }
  }, [_vm.imageLoaded && _vm.isSupportedImage ? _c("div", {
    directives: [{
      name: "click-outside",
      rawName: "v-click-outside",
      value: function value() {
        return _vm.showIcons = false;
      },
      expression: "() => showIcons = false"
    }],
    staticClass: "image__view",
    on: {
      "click": function click($event) {
        _vm.showIcons = true;
      },
      "mouseover": function mouseover($event) {
        _vm.showIcons = true;
      },
      "mouseleave": function mouseleave($event) {
        _vm.showIcons = false;
      }
    }
  }, [_c("transition", {
    attrs: {
      "name": "fade"
    }
  }, [_c("img", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.loaded,
      expression: "loaded"
    }],
    staticClass: "image__main",
    attrs: {
      "src": _vm.imageUrl
    },
    on: {
      "load": _vm.onLoaded
    }
  })]), _c("transition", {
    attrs: {
      "name": "fade"
    }
  }, [_c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.loaded,
      expression: "loaded"
    }],
    staticClass: "image__caption"
  }, [_c("input", {
    ref: "altInput",
    attrs: {
      "type": "text"
    },
    domProps: {
      "value": _vm.alt
    },
    on: {
      "keyup": function keyup($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter"))
          return null;
        return _vm.updateAlt();
      }
    }
  }), _vm.editor.isEditable && _vm.showIcons ? _c("div", {
    staticClass: "trash-icon",
    attrs: {
      "title": "Delete this image"
    },
    on: {
      "click": _vm.deleteNode
    }
  }, [_c("TrashCanIcon")], 1) : _vm._e()])])], 1) : _c("div", [_c("transition", {
    attrs: {
      "name": "fade"
    }
  }, [_c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.loaded,
      expression: "loaded"
    }]
  }, [_c("a", {
    attrs: {
      "href": _vm.internalLinkOrImage,
      "target": "_blank"
    }
  }, [!_vm.isSupportedImage ? _c("span", [_vm._v(_vm._s(_vm.alt))]) : _vm._e()])])]), _vm.isSupportedImage ? _c("transition", {
    attrs: {
      "name": "fade"
    }
  }, [_c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.loaded,
      expression: "loaded"
    }],
    staticClass: "image__caption"
  }, [_c("input", {
    ref: "altInput",
    attrs: {
      "type": "text"
    },
    domProps: {
      "value": _vm.alt
    },
    on: {
      "keyup": function keyup($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter"))
          return null;
        return _vm.updateAlt();
      }
    }
  })])]) : _vm._e()], 1)])]);
};
var staticRenderFns$1 = [];
var ImageView_vue_vue_type_style_index_0_scoped_true_lang = "";
const imageMimes = [
  "image/png",
  "image/jpeg",
  "image/jpg",
  "image/gif",
  "image/x-xbitmap",
  "image/x-ms-bmp",
  "image/bmp",
  "image/svg+xml",
  "image/webp"
];
const getQueryVariable = (src, variable) => {
  const query = src.split("?")[1];
  if (typeof query === "undefined") {
    return;
  }
  const vars = query.split(/[&#]/);
  if (typeof vars === "undefined") {
    return;
  }
  for (let i = 0; i < vars.length; i++) {
    const pair = vars[i].split("=");
    if (decodeURIComponent(pair[0]) === variable) {
      return decodeURIComponent(pair[1]);
    }
  }
};
const __vue2_script$1 = {
  name: "ImageView",
  components: {
    TrashCanIcon,
    NodeViewWrapper
  },
  directives: {
    ClickOutside
  },
  mixins: [
    store
  ],
  inject: ["fileId"],
  props: ["editor", "node", "extension", "updateAttributes", "deleteNode"],
  data() {
    return {
      imageLoaded: false,
      loaded: false,
      failed: false,
      showIcons: false
    };
  },
  computed: {
    currentSession() {
      return this.$store.state.currentSession;
    },
    davUrl() {
      if (getCurrentUser()) {
        const uid = getCurrentUser().uid;
        const encoded = encodeURI(this.imagePath);
        return generateRemoteUrl(`dav/files/${uid}${encoded}`);
      } else {
        return generateUrl("/s/{token}/download?path={dirname}&files={basename}", {
          token: this.token,
          dirname: this.extension.options.currentDirectory,
          basename: this.basename
        });
      }
    },
    imageUrl() {
      if (this.src.startsWith("text://") && this.currentSession) {
        const documentId = this.currentSession.documentId;
        const sessionId = this.currentSession.id;
        const sessionToken = this.currentSession.token;
        const imageFileName = getQueryVariable(this.src, "imageFileName");
        if (getCurrentUser() || !this.token) {
          return generateUrl("/apps/text/image?documentId={documentId}&sessionId={sessionId}&sessionToken={sessionToken}&imageFileName={imageFileName}", {
            documentId,
            sessionId,
            sessionToken,
            imageFileName
          });
        } else {
          return generateUrl("/apps/text/image?documentId={documentId}&sessionId={sessionId}&sessionToken={sessionToken}&imageFileName={imageFileName}&shareToken={shareToken}", {
            documentId,
            sessionId,
            sessionToken,
            imageFileName,
            shareToken: this.token
          });
        }
      }
      if (this.isRemoteUrl || this.isPreviewUrl || this.isDataUrl) {
        return this.src;
      }
      if (this.hasPreview && this.mime !== "image/gif") {
        return this.previewUrl;
      }
      return this.davUrl;
    },
    isRemoteUrl() {
      return this.src.startsWith("http://") || this.src.startsWith("https://");
    },
    isPreviewUrl() {
      return this.src.match(/^(\/index.php)?\/core\/preview/) || this.src.match(/^(\/index.php)?\/apps\/files_sharing\/publicpreview\//);
    },
    isDataUrl() {
      return this.src.startsWith("data:");
    },
    basename() {
      if (this.src.startsWith("text://")) {
        const imageFileName = getQueryVariable(this.src, "imageFileName");
        return `.attachments.${this.fileId}/${imageFileName}`;
      }
      return decodeURI(this.src.split("?")[0]);
    },
    imageFileId() {
      return getQueryVariable(this.src, "fileId");
    },
    imagePath() {
      const f = [
        this.extension.options.currentDirectory,
        this.basename
      ].join("/");
      return path.normalize(f);
    },
    hasPreview() {
      return getQueryVariable(this.src, "hasPreview") === "true" || this.src.startsWith("text://");
    },
    previewUrl() {
      const fileQuery = `file=${encodeURIComponent(this.imagePath)}`;
      const query = fileQuery + "&x=1024&y=1024&a=true";
      if (getCurrentUser() && this.imageFileId) {
        return generateUrl(`/core/preview?fileId=${this.imageFileId}&${query}`);
      }
      if (getCurrentUser()) {
        return generateUrl(`/core/preview.png?${query}`);
      }
      if (this.token) {
        return generateUrl(`/apps/files_sharing/publicpreview/${this.token}?${query}`);
      }
      console.error("No way to authenticate image retrival - need to be logged in or provide a token");
      return "";
    },
    mime() {
      return getQueryVariable(this.src, "mimetype");
    },
    mimeIcon() {
      if (this.mime) {
        const mimeIconUrl = window.OC.MimeType.getIconUrl(this.mime);
        return { backgroundImage: `url(${mimeIconUrl})` };
      }
      return {};
    },
    isSupportedImage() {
      return typeof this.mime === "undefined" || imageMimes.indexOf(this.mime) !== -1;
    },
    internalLinkOrImage() {
      if (this.imageFileId) {
        return generateUrl("/f/" + this.imageFileId);
      }
      return this.src;
    },
    src: {
      get() {
        return this.node.attrs.src || "";
      },
      set(src) {
        this.updateAttributes({
          src
        });
      }
    },
    alt: {
      get() {
        return this.node.attrs.alt ? this.node.attrs.alt : "";
      },
      set(alt) {
        this.updateAttributes({
          alt
        });
      }
    },
    t() {
      return (a, s) => window.t(a, s);
    },
    token() {
      return document.getElementById("sharingToken") && document.getElementById("sharingToken").value;
    }
  },
  beforeMount() {
    if (!this.isSupportedImage) {
      this.failed = true;
      this.imageLoaded = false;
      this.loaded = true;
      return;
    }
    const img = new Image();
    img.onload = () => {
      this.imageLoaded = true;
    };
    img.onerror = () => {
      this.failed = true;
      this.imageLoaded = false;
      this.loaded = true;
    };
    img.src = this.imageUrl;
  },
  methods: {
    updateAlt() {
      this.alt = this.$refs.altInput.value;
    },
    onLoaded() {
      this.loaded = true;
      this.$nextTick(() => {
        this.editor.commands.scrollIntoView();
      });
    }
  }
};
const __cssModules$1 = {};
var __component__$1 = /* @__PURE__ */ normalizeComponent(__vue2_script$1, render$1, staticRenderFns$1, false, __vue2_injectStyles$1, "8286211e", null, null);
function __vue2_injectStyles$1(context) {
  for (let o in __cssModules$1) {
    this[o] = __cssModules$1[o];
  }
}
var ImageView = /* @__PURE__ */ function() {
  return __component__$1.exports;
}();
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Image$1 = TiptapImage.extend({
  selectable: false,
  addOptions() {
    var _a;
    return __spreadProps(__spreadValues({}, (_a = this.parent) == null ? void 0 : _a.call(this)), {
      currentDirectory: void 0
    });
  },
  addNodeView() {
    return VueNodeViewRenderer(ImageView);
  },
  addProseMirrorPlugins() {
    return [
      new Plugin({
        props: {
          handleDrop: (view, event, slice) => {
            if (event.dataTransfer.files && event.dataTransfer.files.length > 0) {
              const coordinates = view.posAtCoords({ left: event.clientX, top: event.clientY });
              const customEvent = new CustomEvent("image-drop", {
                bubbles: true,
                detail: {
                  files: event.dataTransfer.files,
                  position: coordinates.pos
                }
              });
              event.target.dispatchEvent(customEvent);
              return true;
            }
          },
          handlePaste: (view, event, slice) => {
            if (event.clipboardData.files && event.clipboardData.files.length > 0) {
              const customEvent = new CustomEvent("image-paste", {
                bubbles: true,
                detail: {
                  files: event.clipboardData.files
                }
              });
              event.target.dispatchEvent(customEvent);
              return true;
            }
          }
        }
      })
    ];
  }
});
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
var PlainTextDocument = Node.create({
  name: "doc",
  content: "block",
  addKeyboardShortcuts() {
    return {
      Tab: () => this.editor.commands.insertContent("	")
    };
  }
});
/*
 * @copyright Copyright (c) 2021 Jonas Meurer <jonas@freesources.org>
 *
 * @author Jonas Meurer <jonas@freesources.org>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
function listInputRule(find, type, getAttributes) {
  const handler = ({ state, range, match }) => {
    const wrap = wrappingInputRule({ find, type, getAttributes });
    wrap.handler({ state, range, match });
    if (match.length >= 3) {
      state.tr.insertText(match[2]);
    }
  };
  return new InputRule({ find, handler });
}
/*
 * @copyright Copyright (c) 2020 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const BulletList = TiptapBulletList.extend({
  addInputRules() {
    return [
      listInputRule(/^\s*([-+*])\s([^\s[])$/, this.type)
    ];
  }
});
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const TaskItem = TipTapTaskItem.extend({
  addOptions() {
    return {
      nested: true,
      HTMLAttributes: {}
    };
  },
  draggable: false,
  content: "paragraph block*",
  addAttributes() {
    const adjust = __spreadValues({}, this.parent());
    adjust.checked.parseHTML = (el) => {
      var _a;
      return (_a = el.querySelector("input[type=checkbox]")) == null ? void 0 : _a.checked;
    };
    return adjust;
  },
  parseHTML: [
    {
      priority: 101,
      tag: "li",
      getAttrs: (el) => {
        const checkbox = el.querySelector("input[type=checkbox]");
        return checkbox;
      },
      context: "taskList/"
    }
  ],
  renderHTML({ node, HTMLAttributes }) {
    const listAttributes = { class: "checkbox-item" };
    const checkboxAttributes = { type: "checkbox", class: "", contenteditable: false };
    if (node.attrs.checked) {
      checkboxAttributes.checked = true;
      listAttributes.class += " checked";
    }
    return [
      "li",
      mergeAttributes(HTMLAttributes, listAttributes),
      [
        "input",
        checkboxAttributes
      ],
      [
        "label",
        0
      ]
    ];
  },
  addNodeView: false,
  toMarkdown: (state, node) => {
    state.write(`[${node.attrs.checked ? "x" : " "}] `);
    state.renderContent(node);
  },
  addInputRules() {
    return [
      ...this.parent(),
      wrappingInputRule({
        find: /^\s*([-+*])\s(\[(x|X| ?)\])\s$/,
        type: this.type,
        getAttributes: (match) => ({
          checked: "xX".includes(match[match.length - 1])
        })
      })
    ];
  },
  addProseMirrorPlugins() {
    return [
      new Plugin({
        props: {
          handleClick: (view, pos, event) => {
            const state = view.state;
            const schema = state.schema;
            const coordinates = view.posAtCoords({ left: event.clientX, top: event.clientY });
            const position = state.doc.resolve(coordinates.pos);
            const parentList = findParentNodeClosestToPos(position, function(node) {
              return node.type === schema.nodes.taskItem || node.type === schema.nodes.listItem;
            });
            const isListClicked = event.target.tagName.toLowerCase() === "li";
            if (!isListClicked || !parentList || parentList.node.type !== schema.nodes.taskItem) {
              return;
            }
            const tr = state.tr;
            tr.setNodeMarkup(parentList.pos, schema.nodes.taskItem, { checked: !parentList.node.attrs.checked });
            view.dispatch(tr);
          }
        }
      })
    ];
  }
});
/*
 * @copyright Copyright (c) 2020 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const TaskList = TiptapTaskList.extend({
  parseHTML: [
    {
      priority: 100,
      tag: "ul.contains-task-list"
    }
  ],
  toMarkdown: (state, node) => {
    state.renderList(node, "  ", () => (node.attrs.bullet || "*") + " ");
  }
});
/*
 * @copyright Copyright (c) 2021, überdosis GbR
 *
 * @license MIT
 *
 */
function nodeEqualsType({ types, node }) {
  return Array.isArray(types) && types.includes(node.type) || node.type === types;
}
Extension.create({
  name: "trailingNode",
  addOptions() {
    return {
      node: "paragraph",
      notAfter: ["paragraph"]
    };
  },
  addProseMirrorPlugins() {
    const plugin = new PluginKey(this.name);
    const disabledNodes = Object.entries(this.editor.schema.nodes).map(([, value]) => value).filter((node) => this.options.notAfter.includes(node.name));
    return [
      new Plugin({
        key: plugin,
        appendTransaction: (_, __, state) => {
          const { doc, tr, schema } = state;
          const shouldInsertNodeAtEnd = plugin.getState(state);
          const endPosition = doc.content.size;
          const type = schema.nodes[this.options.node];
          if (!shouldInsertNodeAtEnd) {
            return;
          }
          return tr.insert(endPosition, type.create());
        },
        state: {
          init: (_, state) => {
            const lastNode = state.tr.doc.lastChild;
            return !nodeEqualsType({ node: lastNode, types: disabledNodes });
          },
          apply: (tr, value) => {
            if (!tr.docChanged) {
              return value;
            }
            const lastNode = tr.doc.lastChild;
            return !nodeEqualsType({ node: lastNode, types: disabledNodes });
          }
        }
      })
    ];
  }
});
const Heading = TipTapHeading.extend({
  addKeyboardShortcuts() {
    return this.options.levels.reduce((items, level) => __spreadProps(__spreadValues({}, items), {
      [`Mod-Shift-${level}`]: () => this.editor.commands.toggleHeading({ level })
    }), {});
  }
});
/*
 * @copyright Copyright (c) 2022 Vinicius Reis <vinicius@nextcloud.com>
 *
 * @author Vinicius Reis <vinicius@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const typesAvailable = ["info", "warn", "error", "success"];
const buildRender = (type) => (tokens, idx, options, env, slf) => {
  const tag = tokens[idx];
  if (tag.nesting === 1) {
    tag.attrSet("data-callout", type);
    tag.attrJoin("class", `callout callout-${type}`);
  }
  return slf.renderToken(tokens, idx, options, env, slf);
};
var callouts = (md) => {
  typesAvailable.forEach((type) => {
    md.use(container, type, {
      render: buildRender(type)
    });
  });
  return md;
};
/*
 * @copyright Copyright (c) 2022 Vinicius Reis <vinicius@nextcloud.com>
 *
 * @author Vinicius Reis <vinicius@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
var Callout = Node.create({
  name: "callout",
  content: "paragraph+",
  group: "block",
  defining: true,
  addOptions() {
    return {
      types: typesAvailable,
      HTMLAttributes: {
        class: "callout"
      }
    };
  },
  addAttributes() {
    return {
      type: {
        default: "info",
        rendered: false,
        parseHTML: (element) => {
          return element.getAttribute("data-callout") || typesAvailable.find((type) => element.classList.contains(type)) || element.classList.contains("warning") && "warn";
        },
        renderHTML: (attributes) => {
          return {
            "data-callout": attributes.type,
            class: `callout-${attributes.type}`
          };
        }
      }
    };
  },
  parseHTML() {
    return [
      {
        tag: "div.callout"
      },
      {
        tag: "p.callout",
        priority: 1001
      }
    ];
  },
  renderHTML({ node, HTMLAttributes }) {
    const { class: classy } = this.options.HTMLAttributes;
    const attributes = __spreadProps(__spreadValues({}, this.options.HTMLAttributes), {
      "data-callout": node.attrs.type,
      class: `${classy} ${classy}-${node.attrs.type}`
    });
    return ["div", mergeAttributes(attributes, HTMLAttributes), 0];
  },
  toMarkdown: (state, node) => {
    state.write("::: " + (node.attrs.type || "info") + "\n");
    state.renderContent(node);
    state.ensureNewLine();
    state.write(":::");
    state.closeBlock(node);
  },
  addCommands() {
    return {
      setCallout: (attributes) => ({ commands }) => {
        return commands.wrapIn(this.name, attributes);
      },
      toggleCallout: (attributes) => ({ commands, state }) => {
        if (!isNodeActive(state, this.name)) {
          return commands.setCallout(attributes);
        }
        if (!isNodeActive(state, this.name, attributes)) {
          return commands.updateAttributes(this.name, attributes);
        }
        return commands.unsetCallout();
      },
      unsetCallout: () => ({ commands }) => {
        return commands.lift(this.name);
      }
    };
  }
});
/*
 * @copyright Copyright (c) 2022 Max <max@nextcloud.com>
 *
 * @author Max <max@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
*/
Extension.create({
  name: "PlainText",
  addExtensions() {
    return [
      PlainTextDocument,
      Text,
      CodeBlockLowlight
    ];
  }
});
var TableCaption = Node.create({
  name: "tableCaption",
  content: "inline*",
  addAttributes() {
    return {};
  },
  renderHTML() {
    return ["caption"];
  },
  toMarkdown(state, node) {
  },
  parseHTML() {
    return [
      { tag: "table caption", priority: 90 }
    ];
  }
});
var TableCell = TableCell$1.extend({
  content: "inline*",
  toMarkdown(state, node) {
    state.write(" ");
    state.renderInline(node);
    state.write(" |");
  },
  parseHTML() {
    return [
      { tag: "td" },
      { tag: "th" },
      { tag: "table thead ~ tbody th", priority: 70 },
      { tag: "table thead ~ tbody td", priority: 70 }
    ];
  }
});
var TableHeader = TableHeader$1.extend({
  content: "inline*",
  toMarkdown(state, node) {
    state.write(" ");
    state.renderInline(node);
    state.write(" |");
  },
  parseHTML() {
    return [
      { tag: "table thead:empty ~ tbody :first-child th", priority: 80 },
      { tag: "table thead:empty ~ tbody :first-child td", priority: 80 },
      { tag: "table thead :first-child th", priority: 60 },
      { tag: "table thead :first-child td", priority: 60 },
      { tag: "table tbody :first-child th", priority: 60 },
      { tag: "table tbody :first-child td", priority: 60 },
      { tag: "table > :first-child > th", priority: 60 },
      { tag: "table > :first-child > td", priority: 60 }
    ];
  }
});
var TableRow = TableRow$1.extend({
  content: "tableCell*",
  toMarkdown(state, node) {
    state.write("|");
    state.renderInline(node);
    state.ensureNewLine();
  },
  parseHTML() {
    return [
      { tag: "tr", priority: 80 }
    ];
  }
});
var TableHeadRow = TableRow.extend({
  name: "tableHeadRow",
  content: "tableHeader*",
  toMarkdown(state, node) {
    state.write("|");
    state.renderInline(node);
    state.ensureNewLine();
    state.write("|");
    node.forEach((cell) => {
      state.write(state.repeat("-", cell.textContent.length + 2));
      state.write("|");
    });
    state.ensureNewLine();
  },
  parseHTML() {
    return [
      { tag: "tr", priority: 70 }
    ];
  }
});
function createTable(schema, rowsCount, colsCount, cellContent) {
  const headerCells = [];
  const cells = [];
  for (let index = 0; index < colsCount; index += 1) {
    const cell = schema.nodes.tableCell.createAndFill();
    if (cell) {
      cells.push(cell);
    }
    const headerCell = schema.nodes.tableHeader.createAndFill();
    if (headerCell) {
      headerCells.push(headerCell);
    }
  }
  const headRow = schema.nodes.tableHeadRow.createChecked(null, headerCells);
  const rows = [];
  for (let index = 1; index < rowsCount; index += 1) {
    rows.push(schema.nodes.tableRow.createChecked(null, cells));
  }
  return schema.nodes.table.createChecked(null, [headRow, ...rows]);
}
function findSameCellInNextRow($cell) {
  if ($cell.index(-1) === $cell.node(-1).childCount - 1) {
    return null;
  }
  let cellStart = $cell.after();
  const table = $cell.node(-1);
  for (let row = $cell.indexAfter(-1); row < table.childCount; row++) {
    const rowNode = table.child(row);
    if (rowNode.childCount >= $cell.index()) {
      for (let cell = 0; cell < $cell.index(); cell++) {
        const cellNode = rowNode.child(cell);
        cellStart += cellNode.nodeSize;
      }
      return cellStart + 1;
    }
    cellStart += rowNode.nodeSize;
  }
}
var Table = Table$1.extend({
  content: "tableCaption? tableHeadRow tableRow*",
  addExtensions() {
    return [
      TableCaption,
      TableCell,
      TableHeader,
      TableHeadRow,
      TableRow
    ];
  },
  addCommands() {
    return __spreadProps(__spreadValues({}, this.parent()), {
      insertTable: () => ({ tr, dispatch, editor }) => {
        if (isInTable(tr))
          return false;
        const node = createTable(editor.schema, 3, 3);
        if (dispatch) {
          const offset = tr.selection.anchor + 1;
          tr.replaceSelectionWith(node).scrollIntoView().setSelection(TextSelection.near(tr.doc.resolve(offset)));
        }
        return true;
      },
      leaveTable: () => ({ tr, dispatch, editor }) => {
        if (!isInTable(tr))
          return false;
        const { $head, empty } = tr.selection;
        if (!empty)
          return false;
        const tableDepth = $head.depth < 3 ? 1 : $head.depth - 2;
        if (dispatch) {
          const $next = tr.doc.resolve($head.after(tableDepth) + 1);
          const selection = TextSelection.near($next);
          dispatch(tr.setSelection(selection).scrollIntoView());
        }
        return true;
      },
      goToNextRow: () => ({ tr, dispatch, editor }) => {
        if (!isInTable(tr))
          return false;
        const cell = findSameCellInNextRow(selectionCell(tr));
        if (cell == null)
          return;
        if (dispatch) {
          const $cell = tr.doc.resolve(cell);
          const selection = TextSelection.between($cell, moveCellForward($cell));
          dispatch(tr.setSelection(selection).scrollIntoView());
        }
        return true;
      }
    });
  },
  renderHTML({ HTMLAttributes }) {
    return ["table", mergeAttributes(this.options.HTMLAttributes, HTMLAttributes), 0];
  },
  toMarkdown(state, node) {
    state.renderContent(node);
    state.closeBlock(node);
  },
  addKeyboardShortcuts() {
    return __spreadProps(__spreadValues({}, this.parent()), {
      Tab: () => this.editor.commands.goToNextCell() || this.editor.commands.leaveTable(),
      Enter: () => {
        if (this.editor.commands.goToNextRow()) {
          return true;
        }
        if (!this.editor.can().addRowAfter()) {
          return false;
        }
        return this.editor.chain().addRowAfter().goToNextRow().run();
      }
    });
  }
});
/*
 * @copyright Copyright (c) 2022 Max <max@nextcloud.com>
 *
 * @author Max <max@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
function markdownUnderlines(md) {
  md.inline.ruler2.after("emphasis", "underline", (state) => {
    const tokens = state.tokens;
    for (let i = tokens.length - 1; i > 0; i--) {
      const token = tokens[i];
      if (token.markup === "__") {
        if (token.type === "strong_open") {
          tokens[i].tag = "u";
          tokens[i].type = "u_open";
        }
        if (token.type === "strong_close") {
          tokens[i].tag = "u";
          tokens[i].type = "u_close";
        }
      }
    }
    return false;
  });
}
/*
 * @copyright Copyright (c) 2022 Max <max@nextcloud.com>
 *
 * @author Max <max@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
function splitMixedLists(md) {
  md.core.ruler.after("github-task-lists", "split-mixed-task-lists", (state) => {
    const tokens = state.tokens;
    for (let i = 0; i < tokens.length; i++) {
      const token = tokens[i];
      if (token.attrGet("class") !== "contains-task-list") {
        continue;
      }
      const firstChild = tokens[i + 1];
      const startsWithTask = firstChild.attrGet("class") === "task-list-item";
      if (!startsWithTask) {
        token.attrs.splice(token.attrIndex("class"));
        if (token.attrs.length === 0) {
          token.attrs = null;
        }
      }
      const splitBefore = findChildOf(tokens, i, (child) => {
        return child.nesting === 1 && child.attrGet("class") !== firstChild.attrGet("class");
      });
      if (splitBefore > i) {
        splitListAt(tokens, splitBefore, state.Token);
      }
    }
    return false;
  });
}
function splitListAt(tokens, index, TokenConstructor) {
  const closeList = new TokenConstructor("bullet_list_close", "ul", -1);
  closeList.block = true;
  const openList = new TokenConstructor("bullet_list_open", "ul", 1);
  openList.attrSet("class", "contains-task-list");
  openList.block = true;
  tokens.splice(index, 0, closeList, openList);
}
function findChildOf(tokens, parentIndex, predicate) {
  const searchLevel = tokens[parentIndex].level + 1;
  for (let i = parentIndex + 1; i < tokens.length; i++) {
    const token = tokens[i];
    if (token.level < searchLevel) {
      return -1;
    }
    if (token.level === searchLevel && predicate(tokens[i])) {
      return i;
    }
  }
  return -1;
}
const markdownit = MarkdownIt("commonmark", { html: false, breaks: false }).enable("strikethrough").enable("table").use(taskLists, { enable: true, labelAfter: true }).use(splitMixedLists).use(markdownUnderlines).use(callouts);
/*
 * @copyright Copyright (c) 2020 Azul <azul@riseup.net>
 *
 * @author Azul <azul@riseup.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const absolutePath = function(base, rel) {
  if (!rel) {
    return base;
  }
  if (rel[0] === "/") {
    return rel;
  }
  base = base.split("/");
  rel = rel.split("/");
  while (rel[0] === ".." || rel[0] === ".") {
    if (rel[0] === "..") {
      base.pop();
    }
    rel.shift();
  }
  return base.concat(rel).join("/");
};
const basedir = function(file) {
  const end = file.lastIndexOf("/");
  return end > 0 ? file.slice(0, end) : file.slice(0, end + 1);
};
const domHref = function(node) {
  const ref = node.attrs.href;
  if (!ref) {
    return ref;
  }
  if (ref.match(/^[a-zA-Z]*:/)) {
    return ref;
  }
  const match = ref.match(/^([^?]*)\?fileId=(\d+)/);
  if (match) {
    const [, relPath, id] = match;
    const currentDir = basedir(OCA.Viewer.file);
    const dir = absolutePath(currentDir, basedir(relPath));
    return generateUrl(`/apps/files/?dir=${dir}&openfile=${id}#relPath=${relPath}`);
  }
};
const parseHref = function(dom) {
  const ref = dom.getAttribute("href");
  if (!ref) {
    return ref;
  }
  const match = ref.match(/\?dir=([^&]*)&openfile=([^&]*)#relPath=([^&]*)/);
  if (match) {
    const [, , id, path2] = match;
    return `${path2}?fileId=${id}`;
  }
  return ref;
};
const openLink = function(event, _attrs) {
  const linkElement = event.target.closest("a");
  event.stopPropagation();
  const htmlHref = linkElement.href;
  if (event.button === 0 && !event.ctrlKey && htmlHref.startsWith(window.location.origin)) {
    const query = OC.parseQueryString(htmlHref);
    const fragment = OC.parseQueryString(htmlHref.split("#").pop());
    if (query.dir && fragment.relPath) {
      const filename = fragment.relPath.split("/").pop();
      const path2 = `${query.dir}/${filename}`;
      document.title = `${filename} - ${OC.theme.title}`;
      if (window.location.pathname.match(/apps\/files\/$/))
        ;
      OCA.Viewer.open({ path: path2 });
      return;
    }
    if (query.fileId) {
      window.open(generateUrl(`/f/${query.fileId}`));
      return;
    }
  }
  if (!markdownit.validateLink(htmlHref)) {
    console.error("Invalid link", htmlHref);
    return false;
  }
  window.open(htmlHref);
  return true;
};
const clickHandler = ({ editor, type, onClick }) => {
  return new Plugin({
    props: {
      key: new PluginKey("textLink"),
      handleClick: (view, pos, event) => {
        const $clicked = view.state.doc.resolve(pos);
        const link = $clicked.marks().find((m) => m.type.name === type.name);
        if (!link) {
          return false;
        }
        if (!link.attrs.href) {
          console.warn("Could not determine href of link.");
          console.debug(link);
          return false;
        }
        return onClick == null ? void 0 : onClick(event, link.attrs);
      }
    }
  });
};
/*
 * @copyright Copyright (c) 2019 Azul <azul@riseup.net>
 *
 * @author Azul <azul@riseup.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Link = TipTapLink.extend({
  addOptions() {
    var _a;
    return __spreadProps(__spreadValues({}, (_a = this.parent) == null ? void 0 : _a.call(this)), {
      onClick: openLink
    });
  },
  addAttributes() {
    return {
      href: {
        default: null
      }
    };
  },
  inclusive: false,
  parseHTML: [
    {
      tag: "a[href]",
      getAttrs: (dom) => ({
        href: parseHref(dom)
      })
    }
  ],
  renderHTML: ({ mark, HTMLAttributes }) => ["a", __spreadProps(__spreadValues({}, mark.attrs), {
    href: domHref(mark),
    title: mark.attrs.href,
    rel: "noopener noreferrer nofollow"
  }), 0],
  addProseMirrorPlugins() {
    const plugins = this.parent().filter(({ key }) => {
      return !key.startsWith("handleClickLink");
    });
    if (!this.options.openOnClick) {
      return plugins;
    }
    return [
      ...plugins,
      clickHandler({
        editor: this.editor,
        type: this.type,
        onClick: this.options.onClick
      })
    ];
  }
});
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
var Strike = TipTapStrike.extend({
  parseHTML() {
    return [
      {
        tag: "s"
      },
      {
        tag: "del"
      },
      {
        tag: "strike"
      },
      {
        style: "text-decoration",
        getAttrs: (value) => value === "line-through"
      }
    ];
  },
  renderHTML() {
    return ["s", 0];
  },
  toMarkdown: {
    open: "~~",
    close: "~~",
    mixable: true,
    expelEnclosingWhitespace: true
  }
});
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Strong = Bold.extend({
  name: "strong",
  addInputRules() {
    return [
      markInputRule({
        find: starInputRegex,
        type: this.type
      })
    ];
  },
  addPasteRules() {
    return [
      markPasteRule({
        find: starPasteRegex,
        type: this.type
      })
    ];
  }
});
/*
 * @copyright Copyright (c) 2022 Max <max@nextcloud.com>
 *
 * @author Max <max@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Underline = TipTapUnderline.extend({
  parseHTML() {
    return [
      {
        tag: "u"
      },
      {
        style: "text-decoration",
        getAttrs: (value) => value === "underline"
      }
    ];
  },
  renderHTML() {
    return ["u", 0];
  },
  toMarkdown: {
    open: "__",
    close: "__",
    mixable: true,
    expelEnclosingWhitespace: true
  },
  addInputRules() {
    return [
      markInputRule({
        find: underscoreInputRegex,
        type: this.type
      })
    ];
  },
  addPasteRules() {
    return [
      markPasteRule({
        find: underscorePasteRegex,
        type: this.type
      })
    ];
  }
});
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Italic = TipTapItalic.extend({
  name: "em"
});
/*
 * @copyright Copyright (c) 2022 Max <max@nextcloud.com>
 *
 * @author Max <max@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
*/
var RichText = Extension.create({
  name: "RichText",
  addOptions() {
    return {
      currentDirectory: void 0,
      link: {}
    };
  },
  addExtensions() {
    const extensions = [
      Document,
      Text,
      Paragraph,
      Heading,
      Strong,
      Italic,
      Strike,
      Blockquote,
      CodeBlock,
      BulletList,
      HorizontalRule,
      OrderedList,
      ListItem,
      Table,
      TaskList,
      TaskItem,
      Callout,
      Underline,
      Image$1.configure({
        currentDirectory: this.options.currentDirectory,
        inline: true
      }),
      Dropcursor
    ];
    if (this.options.link !== false) {
      extensions.push(Link.configure(__spreadProps(__spreadValues({}, this.options.link), {
        openOnClick: true
      })));
    }
    return extensions;
  }
});
var render = function __render__3() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _vm.editor ? _c("EditorContent", {
    attrs: {
      "id": "read-only-editor",
      "editor": _vm.editor
    }
  }) : _vm._e();
};
var staticRenderFns = [];
var RichtextReader_vue_vue_type_style_index_0_lang = "";
const __vue2_script = {
  name: "RichtextReader",
  components: { EditorContent },
  inject: ["currentDirectory"],
  props: {
    content: {
      type: String,
      required: true
    }
  },
  data: () => {
    return {
      editor: null
    };
  },
  computed: {
    htmlContent() {
      return markdownit.render(this.content);
    }
  },
  watch: {
    content() {
      this.updateContent();
    }
  },
  mounted() {
    this.editor = this.createEditor();
    this.editor.setOptions({ editable: false });
  },
  beforeDestroy() {
    this.editor.destroy();
  },
  methods: {
    createEditor() {
      return new Editor({
        content: this.htmlContent,
        extensions: [
          RichText.configure({
            currentDirectory: this.currentDirectory,
            link: {
              onClick: (event, attrs) => this.$emit("click-link", event, attrs)
            }
          })
        ]
      });
    },
    updateContent() {
      this.editor.commands.setContent(this.htmlContent);
    }
  }
};
const __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (let o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var RichtextReader = /* @__PURE__ */ function() {
  return __component__.exports;
}();
export { RichtextReader };
